# MyApplication.py

# imports
import MyCartFunctions # import ModuleName
import MyAdminFunctions
import datetime
import MyOrderFunctions as mof

# Entry Point for our Python Program
# use a try block to loop thry each step for pass/fail
## If step passes, it moves on to the next step
## If step fails, it is captured by the except keyword
## optional third keyword finally (runs a final operation(s) when either pass or fail)

def main(): # __name__ == __main__
    try:

        # As functional program as possible

        # Call the customer info
        # firstName, lastName = return position1, position2
        firstName, lastName =  MyAdminFunctions.customerInfo()
        print(f"{lastName}, {firstName}")

        # Call the customer info
        # object1 = return position1, position2
        # tuple = (position1, position2)
        objCustomerInfo = MyAdminFunctions.customerInfo()
        print(objCustomerInfo)
        print(objCustomerInfo[1])
        print(objCustomerInfo[0])

        # Call the customer info using lambda
        lambda_fullName = MyAdminFunctions.fullName("Jane", "Doe")
        print(lambda_fullName)

        # Order Information
        # Create a basic order using object with 2 items
        # use the current datetime stamp for the order date

        # datetime Module has 4 classes that you will commonly use
        # class datetime gives you both date and time
        # class date gives you date with time as 00:00:00.000000
        # class time gives you just time HH:MM:SS.mmmmmm
        # class timedelta allows you to calculate dates and times
        ## invoiceDate + timedelta(days=30) = dueDate
        orderDate = datetime.datetime.now()

        basic_order = MyCartFunctions.create_order("1234", orderDate)
        MyCartFunctions.display_order(basic_order)

        enhansed_order = MyCartFunctions.create_enhansed_order("ABCD", orderDate, 101.25) # total comes from cartTotal3

        # Will not get expected x but got y exception error
        # functions expecting 1 arg as obj passed to 1 param as obj
        MyCartFunctions.display_enhansed_order(enhansed_order) # 1 object passed, using 3 items
        MyCartFunctions.display_order(enhansed_order) # 1 objects passed using 2 of the 3 items

        # Call the credit card processor
        #MyCartFunctions.creditCardInfo()

        # Save orders after credit card processing
        fn = mof.filename # scopevariable = importedvariable
        mof.write_orders_to_csv(fn, mof.orders)

        # Define a variable that assigns the list from the return keyword
        read_orders = mof.read_orders_from_csv(fn)

        # Print the orders from read_orders
        print("===== Orders from CSV file =====")
        for order in read_orders:
            print(order)
        print("================================")

    # Error Handling cause an Exit Code 1
    except ValueError as err:
        print("You entered an invalid value. Ask them if they want to do something?")

    except FileNotFoundError as err:
        print("Could not find the file referenced...")

    except Exception as err:
        print("General Error: " + str(err))
        # send the error to a log file
        # Chapter 4 Output to a TXT file Errors with a formatted date on the filename
        ## datetime.now() format a date 08202024 
        ## logfile_08202024.txt
        ## send the err to the log file  with open()

    # Optional finally runs pass or fail
    finally:
        print("Thank you for using the program.")
        # close db, csv, buffers
        # clear memory
        # cleanup objects

if __name__ == "__main__": # page 35
    print("Initalizing My Application")
    main()