# PythonFunctions.py
# Chapter 3

# Function vs Method
## where the return value is sent / stored / returned
## Functions return to themselves
## Methods return to something else
### return is always the last step

# Three types of parameters for a function/method
## myFunction() empty parameter > do not get passed values
## myFunction(param1, param2, ...) parameterized function
## call the function arg1("Bob"),arg2("Smith")  
### ("Bob","Smith")
## define the function param1(fname), param2(lname)
### (firstName, lastName)
## myFunction(param1,param2, param3="defaultValue") Query String Parameter or Sets a default value for a param
### define functionName(firstName, lastName, vipStatus=false)
### call functionname("Bob,"Smith") with false for param3
### call functionName("Bob","Smith", true) then vipStatus assigned true from the passed value
## In Python, all default/query string params must be at the end of the tuple

# Empty Function
## Define the Function first with the def keyword
def myCartCalc():
    # local variables in the scope
    subTotal = 52.50
    tax = 5.00
    cartTotal = subTotal + tax
    print(cartTotal)
# Call the function
myCartCalc()

# Parameterized Function
def myCartCalc1(subTotal1, tax1):
    cartTotal1 = subTotal1 + tax1
    print(cartTotal1)
# Call the function and pass 2 args
myCartCalc1(52.50, 5.00)

# Query String Parameter
def myCartCalc2(subTotal2, tax2=0.00):
    cartTotal2 = subTotal2 + tax2
    print(cartTotal2)
# Call the function and only pass first arg
myCartCalc2(52.50)

# Shipping Calculator Function
## if statement for the shipping table using the subTotal
### 0 - 25 5.99
### 25.01 - 50 6.99
### 50.01 - 75 7.99
### > 75 0.00 "Free Shipping"
# Calling the shipping function in the cartCalc() and add to the cartTotal

def myCartCalc3(subTotal3, tax3=0):
    # neg number or empty cart would have been validated before this point
    if subTotal3 > 0 and subTotal3 <= 25:
        shipping3 = 5.99
    elif subTotal3 > 25 and subTotal3 <= 50:
        shipping3 = 6.99
    elif subTotal3 > 50 and subTotal3 <= 75:
        shipping3 = 7.99
    else:
        # this would be any value 75 or more
        shipping3 = 0.00
    # print(shipping3)
    cartTotal3 = subTotal3 + tax3 + shipping3
    # We need the calculated cartTotal3 OUTSIDE the scope of the function
    # we are going to use the return keyword to return the value to the call of the function
    return cartTotal3  # return the value back to the call

# We need to assign a local variable outside the scope of the return to get the value
cartTotal3_App = myCartCalc3(45.52, 8)
print(cartTotal3_App)



# EOF