# PythonTXTFiles.py
# Chapter 4 File I/O

# open() function Python Core
# depending on the type of file .txt .csv etc you may need to import a module that supports that file type
# txt files natively supported by python
# csv files import csv Module Python Standard

# open() has 3 common modes to open a file
## read "r" reads a file into buffer/memory
## write "w" if file exists OVERRIDE all data in the file, if the file does not exist, create a new file, with the data.
## append "a" if the exists, append to the end of the file, if the file does not exists, ceate a new file, with the data.

# newline attributes of files
## txt files DO NOT have native line breaks. Which means if you append data, it adds to the existing data. If you want a line break, you must add it manually "\n".
## csv files HAVE newline (aka new row) so there is no need for "\n" line break.

firstName = input("Enter Contact First Name: ")
lastName = "Smith"
contactInfo = firstName + ", " + lastName + ", 123 Main Street, New York, New York, 12345"
# contactInfo is what we are going to write to the file

# FilePath has 2 options
## relative path "contacts.txt" root dir of program
## absolute path "c:\dir\filename.txt"
# URI or URL Paths
## paths to internet or intranet locations

fileName = "contacts.txt"

with open(fileName, "a") as myFile:
    # with keyword closes the file connection
    contactInfoLineBreak = contactInfo + "\n"
    myFile.write(contactInfoLineBreak)

with open(fileName, "r") as myFile:
    content = myFile.read()

print(content)